def lunar_addition(a, b):
    # Преобразуем числа в строки для поразрядной обработки
    a, b = str(a), str(b)

    # Выравниваем длины чисел, дополняя нулями слева
    max_len = max(len(a), len(b))
    a, b = a.zfill(max_len), b.zfill(max_len)

    # Лунное сложение: максимум для каждой пары цифр
    result = ''.join(str(max(int(x), int(y))) for x, y in zip(a, b))
    return result


def lunar_multiplication(a, b):
    a, b = str(a), str(b)
    partial_results = []

    # Обработка каждой цифры числа b
    for i, digit_b in enumerate(reversed(b)):
        partial_result = ''

        # Умножаем число a на каждую цифру из числа b
        for digit_a in a:
            partial_result += str(min(int(digit_a), int(digit_b)))  # Выбираем минимальное число из пары цифр

        # Сдвигаем результат на нужное количество разрядов
        partial_results.append(partial_result + '0' * i)

    # Складываем все частичные результаты лунным сложением
    result = partial_results[0]
    for pr in partial_results[1:]:
        result = lunar_addition(result, pr)

    return result


# Чтение входных данных
a = input().strip()
b = input().strip()

# Вычисляем лунную сумму и произведение
lunar_sum = lunar_addition(a, b)
lunar_product = lunar_multiplication(a, b)

# Вывод результата
print(lunar_sum, lunar_product)

