from math import gcd


def moritz_achilles_path(a, b):
    # Проверяем, является ли дробь несократимой
    if gcd(a, b) != 1:
        return "no"

    path = ""
    while not (a == 1 and b == 1):  # Пока дробь не достигнет корня (1/1)
        if a < b:  # Если дробь меньше 1, идем влево (L)
            path += "L"
            b -= a
        else:  # Если дробь больше 1, идем вправо (R)
            path += "R"
            a -= b
    return path[::-1]  # Разворачиваем строку, чтобы получить путь от корня к дроби


# Основная часть программы
if __name__ == "__main__":
    # Ввод данных
    a, b = map(int, input("Введите числитель и знаменатель через пробел: ").split())

    # Вычисляем результат
    result = moritz_achilles_path(a, b)

    # Выводим результат
    print(result)
