from collections import defaultdict, deque


def find_protected_warehouses(n, m, k, roads, guards):
    # Построение графа
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    # Набор всех охраняемых складов
    protected = set()

    # BFS для каждого охранника
    for p, h in guards:
        visited = set()  # Посещённые склады
        queue = deque([(p, 0)])  # Очередь: (номер склада, текущая дистанция)

        while queue:
            current, distance = queue.popleft()
            if current in visited or distance > h:
                continue
            visited.add(current)
            protected.add(current)
            for neighbor in graph[current]:
                if neighbor not in visited:
                    queue.append((neighbor, distance + 1))

    # Подготовка результата
    protected_sorted = sorted(protected)
    return len(protected_sorted), protected_sorted


# Чтение входных данных
n, m, k = map(int, input().split())  # Количество складов, дорог, охранников
roads = [tuple(map(int, input().split())) for _ in range(m)]  # Дороги между складами
guards = [tuple(map(int, input().split())) for _ in range(k)]  # Охранники и их выносливость

# Решение задачи
count, protected_warehouses = find_protected_warehouses(n, m, k, roads, guards)

# Вывод результата
print(count)
print(" ".join(map(str, protected_warehouses)))
