from itertools import permutations
import math


def calculate_distance(route, points):
    distance = 0
    for i in range(len(route) - 1):
        x1, y1 = points[route[i]]
        x2, y2 = points[route[i + 1]]
        distance += math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)
    return distance


def solve_n3():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]

    min_distance = float('inf')
    for perm in permutations(range(n)):
        distance = calculate_distance(perm, points)
        min_distance = min(min_distance, distance)

    print(f"{min_distance:.6f}")


solve_n3()





















